<?php 
/**
 * This file is part of workerman.
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the MIT-LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @author walkor<walkor@workerman.net>
 * @copyright walkor<walkor@workerman.net>
 * @link http://www.workerman.net/
 * @license http://www.opensource.org/licenses/mit-license.php MIT License
 */
use \Workerman\Worker;
use \Workerman\WebServer;
use \GatewayWorker\Gateway;
use \GatewayWorker\BusinessWorker;
use \Workerman\Autoloader;


// 证书最好是申请的证书
$context = array(
    // 更多ssl选项请参考手册 http://php.net/manual/zh/context.ssl.php
    'ssl' => array(
        // 请使用绝对路径
        'local_cert'            => 'server.pem', // 也可以是crt文件
        'local_pk'              => 'server.key',
        'verify_peer'           => false,
        'allow_self_signed'     => true, //如果是自签名证书需要开启此选项
    )
);
// websocket协议(端口任意，只要没有被其它程序占用就行)
//$gateway = new Gateway("websocket://0.0.0.0:8282 ", $context);
// 开启SSL，websocket+SSL 即wss
//$gateway->transport = 'ssl';


// gateway 进程，这里使用Text协议，可以用telnet测试
$gateway = new Gateway("websocket://0.0.0.0:8800");
// gateway名称，status方便查看
$gateway->name = 'chat_gateway';
// gateway进程数
$gateway->count = 1;
// 本机ip，分布式部署时使用内网ip
$gateway->lanIp = '127.0.0.1';
// 内部通讯起始端口，假如$gateway->count=4，起始端口为4000
// 则一般会使用4000 4001 4002 4003 4个端口作为内部通讯端口 
$gateway->startPort = 2900;
// 服务注册地址
$gateway->registerAddress = '127.0.0.1:1238';

// 心跳间隔
$gateway->pingInterval = 10;
// 心跳数据
$gateway->pingData = '{"type":"ping"}';
//$gateway->pingNotResponseLimit = 2;


// 当客户端连接上来时，设置连接的onWebSocketConnect，即在websocket握手时的回调
$gateway->onConnect = function($connection)
{
    $connection->onWebSocketConnect = function($connection , $http_header)
    {
        if($_SERVER['HTTP_ORIGIN'] != 'http://xxx')
        {
            //$connection->close();
        }

        // 可以在这里判断连接来源是否合法，不合法就关掉连接
        // $_SERVER['HTTP_ORIGIN']标识来自哪个站点的页面发起的websocket链接
        //Gateway::sendToClient("Hello !\n");
        // onWebSocketConnect 里面$_GET $_SERVER是可用的
        //var_dump($_GET, $_SERVER);

//        if ( empty( $_GET['sn'] ) ) {
//            $connection->close();
//            return;
//        }

        $_SESSION['sn'] = isset($_GET['sn']) ? $_GET['sn'] : 'def';
    };
};

// 如果不是在根目录启动，则运行runAll方法
if(!defined('GLOBAL_START')) {
    Worker::runAll();
}

